/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER         "0.1"
#define BUFFSZ      4096
#define UBIENCDATA1 "ghds8gdsg4o320fw90ge90g34jgwaj4gwj4g90asjg9sj49agj940asga"
#define UBIENCDATA2 "hgf8hsdgh84h98ashf230w20j0th934n923h"
#define PASS        "LastUserPassword="



#ifndef WIN32
    #define strnicmp strncasecmp
#endif

#ifndef u_char
    #define u_char  unsigned char
#endif



void ubicom_pwd(u_char *pwd);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE    *fd;
    u_char  *buff,
            *ptr,
            *ptr1;


    setbuf(stdout, NULL);

    fputs("\n"
        "Ubi.com password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <nickname.cfg>\n"
            "\n"
            "nickname.cfg is one of the files located in the directory Profiles\n"
            "\n", argv[0]);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    printf("\nOpening file %s\n\n", argv[1]);
    fd = fopen(argv[1], "rb");
    if(!fd) std_err();

    buff = malloc(BUFFSZ + 1);
    if(!buff) std_err();

    while(1) {
        if(!fgets(buff, BUFFSZ, fd)) break;

        if(!strnicmp(buff, PASS, sizeof(PASS) - 1)) {
            ptr = buff + sizeof(PASS) - 1;
            for(ptr1 = ptr; *ptr1 > 0xd; ptr1++);
            *ptr1 = 0;

            ubicom_pwd(ptr);
            printf("Password:   %s\n", ptr);
        }
    }

    fclose(fd);
    fputs("\n\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void ubicom_pwd(u_char *pwd) {
    u_char  *encdata1,
            *encdata2;

    encdata1 = UBIENCDATA1;
    encdata2 = UBIENCDATA2;
    while(*pwd) {
        *pwd++ ^= (*encdata1++ ^ *encdata2++);
        if(!*encdata1) encdata1 = UBIENCDATA1;
        if(!*encdata2) encdata2 = UBIENCDATA2;
    }
}



void std_err(void) {
    perror("\nError");
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}


